if ENV['BIRDIE_DEBUG']
  Lotus::Controller.configure do
    handle_exceptions false
  end
end

module Birdie
  module Controller
    def self.extended(base)
      base.send(:include, Lotus::Controller)
    end

    def builder(klass)
      @builder_klass = klass
    end

    def index_action(&block)
      define_action('Index', &block)
    end

    def show_action(&block)
      define_action('Show', &block)
    end

    def create_action(&block)
      define_action('Create', &block)
    end

    def update_action(&block)
      define_action('Update', &block)
    end

    def destroy_action(&block)
      define_action('Destroy', &block)
    end

    private

    def define_action(name, &block)
      block ||= Proc.new{ [] }
      action(name, &action_block)
      const = self.const_get(name)
      const.exec_block = block
      const.builder_klass = @builder_klass
    end

    def action_block
      Proc.new do
        class << self
          attr_accessor :builder_klass, :exec_block
        end

        def call(params)
          items = instance_eval(&self.class.exec_block)
          collection = self.class.builder_klass.new(items, context: self).serialize
          self.body = JSON.dump(collection)
        end

        def path_for(*args)
          Birdie::Application.app.router.path(*args)
        end
      end
    end
  end
end